SystemOrganization addCategory: #RTMDSLayout!

RTLayout subclass: #RTMDSLayout
	instanceVariableNames: 'relBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'RTMDSLayout'!

!RTMDSLayout class methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/13/2014 13:45'!
on: aCollection with: aBlock 
	^ self new on: aCollection with: aBlock ! !

!RTMDSLayout methodsFor: 'hook' stamp: 'NataliaTymchuk 6/25/2014 12:52'!
doExecute: elements
	| models aMatrix coordinates |
	models := elements collect: #model. 
	aMatrix := DhbMatrix new: elements size.
	models
		withIndexDo: [ :fst :index1 | 
			(models allButFirst: index1 - 1)
				withIndexDo: [ :snd :index2 | |a| a:= relBlock value: fst value: snd.
					aMatrix
						at: index1 at: index1 + index2 - 1 put: a;
						at: index1 + index2 - 1 at: index1 put: a ] ].
	coordinates := self сoordinates: (self matrixBInMDS: aMatrix).
	coordinates rows withIndexDo:[ :vect :index | 
		(elements at: index) translateTo: vect first @ vect last ] ! !

!RTMDSLayout methodsFor: 'hook' stamp: 'NataliaTymchuk 5/13/2014 13:40'!
initialize
	super initialize.
	relBlock := [ :first :second | 
		(first hash - second hash) abs ]! !

!RTMDSLayout methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/13/2014 10:12'!
jMatrixInMDS
	^ (DhbMatrix new: self numberOfItems with: [ :c :r | 
			c = r
				ifTrue: [ 1 ]
				ifFalse: [ 0 ] ]) - (DhbMatrix new: self numberOfItems with: [ :c :r | 1 / self numberOfItems ])! !

!RTMDSLayout methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/25/2014 12:49'!
jMatrixInMDSOf: size
	^ (DhbMatrix new: size with: [ :c :r | 
			c = r
				ifTrue: [ 1 ]
				ifFalse: [ 0 ] ]) - (DhbMatrix new: size with: [ :c :r | 1 / size ])! !

!RTMDSLayout methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 6/25/2014 12:49'!
matrixBInMDS: aMatrix

	^((DhbMatrix new: aMatrix rows size with: [ :c :r | 
			c = r
				ifTrue: [ -1/2 ]
				ifFalse: [ 0 ] ]) * (self jMatrixInMDSOf: aMatrix rows size))* (aMatrix collect: #squared ) * (self jMatrixInMDSOf: aMatrix rows size)! !

!RTMDSLayout methodsFor: 'accessing' stamp: 'NataliaTymchuk 5/13/2014 16:35'!
maxYIn:points
points! !

!RTMDSLayout methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/13/2014 13:44'!
on: aCollection with: aBlock 
	^ self
		relBlock: aBlock;
		on: aCollection! !

!RTMDSLayout methodsFor: 'accessing' stamp: 'NataliaTymchuk 5/13/2014 13:40'!
relBlock
	^ relBlock! !

!RTMDSLayout methodsFor: 'accessing' stamp: 'NataliaTymchuk 5/13/2014 13:40'!
relBlock: anObject
	relBlock := anObject! !

!RTMDSLayout methodsFor: 'as yet unclassified' stamp: 'NataliaTymchuk 5/16/2014 11:50'!
сoordinates: matrBInMDS
	| j matrixOfTwoEigenvalues matrixOfTwoTranspEigenvectors |
	j := DhbJacobiTransformation matrix: matrBInMDS.
	matrixOfTwoEigenvalues := DhbMatrix diagonal: (j evaluate sort last: 2).
	matrixOfTwoTranspEigenvectors := (DhbMatrix rows: (j transform rows first: 2)) transpose.
	^ matrixOfTwoTranspEigenvectors * matrixOfTwoEigenvalues! !
